
/**
 * aes 解密方法
 */
function AesDecrypt(word, key, iv) {
    key = CryptoJS.enc.Utf8.parse(key);
    iv = CryptoJS.enc.Utf8.parse(iv);
    let encryptedHexStr = CryptoJS.enc.Hex.parse(word);
    let srcs = CryptoJS.enc.Base64.stringify(encryptedHexStr);
    let decrypt = CryptoJS.AES.decrypt(srcs, key, {
        iv: iv,
        mode: CryptoJS.mode.CBC,
        padding: CryptoJS.pad.Pkcs7
    });
    let decryptedStr = decrypt.toString(CryptoJS.enc.Utf8);
    return decryptedStr.toString();
}
/**
 * aes 加密方法
 */
function AesEncrypt(word, key, iv) {
    key = CryptoJS.enc.Utf8.parse(key);
    iv = CryptoJS.enc.Utf8.parse(iv);
    let srcs = CryptoJS.enc.Utf8.parse(word);
    let encrypted = CryptoJS.AES.encrypt(srcs, key, {
        iv: iv,
        mode: CryptoJS.mode.CBC,
        padding: CryptoJS.pad.Pkcs7
    });
    return encrypted.ciphertext.toString().toUpperCase();
}

/**
 * base64 加密方法
 */
function Base64Encode(val) {
    let str = CryptoJS.enc.Utf8.parse(val);
    let base64 = CryptoJS.enc.Base64.stringify(str);
    return base64;
}

/**
 * base64 解密方法
 */
function Base64Decode(val) {
    let words = CryptoJS.enc.Base64.parse(val);
    return words.toString(CryptoJS.enc.Utf8);
}


/**
 * 字符串转16进制
 */
function StrToHex(str) {
    if (str === "")
        return "";
    var hexCharCode = [];
    // hexCharCode.push("0x");
    for (var i = 0; i < str.length; i++) {
        hexCharCode.push((str.charCodeAt(i)).toString(16));
    }
    return hexCharCode.join("");
}


/**
 * 16进制转字符串
 */
function HexToStr(hexCharCodeStr) {
    var rawStr = hexCharCodeStr.trim();
    if (rawStr === "") return "";
    // var rawStr = trimedStr.substr(0, 2).toLowerCase() === "0x" ? trimedStr.substr(2) : trimedStr;
    var len = rawStr.length;
    if (len % 2 !== 0) {
        return "";
    }
    var curCharCode;
    var resultStr = [];
    for (var i = 0; i < len; i = i + 2) {
        curCharCode = parseInt(rawStr.substr(i, 2), 16); // ASCII Code Value
        resultStr.push(String.fromCharCode(curCharCode));
    }
    return resultStr.join("");
}


function groupArray(str) {
    var result = new Array();
    for (var i = 0; i < str.length / 2; i++) {
        var aa = str.slice(i * 2, (i + 1) * 2);
        result.push(aa);
    }
    return result;
}
function hexToString(str) {
    var arr = groupArray(str);    //将16进制字符串进行每两个分组
    var val = "";
    for (var i = 0; i < arr.length; i++) {
        val += String.fromCharCode(parseInt(arr[i], 16));    //将分组后的16进制字符串转10进制Unicode码,然后将Unicode码转换为字符
    }
    return val;
}
/**
 * 对秘钥MD5加密取前16位
 */
function StrToMd5(str) {
    if(str === "") return "";
    var md5Str = md5(str).substr(0, 16);

    return md5Str.split('').reverse().join('');
}
/**
 * 获取随机字符串
 * @param {*} length 
 */
function randomString(length) { 
 var str = '0123456789abcdefghijklmnopqrstuvwxyz'; 
 var result = ''; 
 for (var i = length; i > 0; --i) result += str[Math.floor(Math.random() * str.length)]; 
 return md5(result).substring(0,22)
}
/**
 * 签名加密
 * @param {*} time 
 * @param {*} sign 
 */
function getHeadSign(time,sign){
	let randomStr = randomString(22);
	return `${md5(time+sign+randomStr)}${time}${randomStr}`
}
/**
 * 签名加密
 * @param {*} time 
 * @param {*} sign 
 */
function createUuid(){
	let randomStr = randomString(22)+new Date().getTime();
	return md5(randomStr);
}
/**
 * 接口返回解密
 * key + ‘a’ 再MD5
 */
function decryptAjax(key,value){
	
	

	
	let keyHex = StrToHex(key);
	let iv = StrToMd5(keyHex);
	let riv = iv.split('').reverse().join('');
	let res = AesDecrypt(value, riv, iv)
	try{
		return JSON.parse(res);
	}catch(e){
		return res;
		//TODO handle the exception
	}
}


